import {AfterContentInit, Component, OnInit} from '@angular/core';
import {AppService} from "./app.service";
import { NzSelectModule } from 'ng-zorro-antd/select';
import { getISOWeek } from 'date-fns';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements OnInit, AfterContentInit {
  title = 'angularproject';
  registerUser: any
  serviceDemand: any
  joinOrgCount: any
  financingDemand: any
  creditAmount: any
  creditUserProportion: any
  creditVillageCount: any
  coverRegionCount: any
  creditVillageProportion: any
  creditUserJoinCount: any
  creditTownProportion: any
  creditTownCount: any
  coverRegionProportion: any
  public date: any = null

  constructor(public httpService: AppService) {
  }

  ngOnInit() {
  }

  ngAfterContentInit() {
    this.httpService.get({
      url: 'https://www.taxbk.cn/qj/api/pc/achievement/baseData', success: (res: any) => {
        this.registerUser = res.registerUser
        this.serviceDemand = res.serviceDemand
        this.joinOrgCount = res.joinOrgCount
        this.financingDemand = res.financingDemand
      }
    })
    this.httpService.get({
      url: 'https://www.taxbk.cn/qj/api/pc/achievement/operate', success: (res: any) => {
        this.creditAmount = res.creditAmount
        console.log(res)
      }
    })
    this.httpService.get({
      url: 'https://www.taxbk.cn/qj/api/pc/achievement/creditStatistics', success: (res: any) => {
        this.creditUserProportion = res.creditUserProportion
        this.creditVillageCount = res.creditVillageCount
        this.coverRegionCount = res.coverRegionCount
        this.creditVillageProportion = res.creditVillageProportion
        this.creditUserJoinCount = res.creditUserJoinCount
        this.creditTownProportion = res.creditTownProportion
        this.creditTownCount = res.creditTownCount
        this.coverRegionProportion = res.coverRegionProportion
      }
    })
  }

  onChange(result: Date): void {
    console.log('onChange: ', result);
  }
}
