import {AfterContentInit, NgModule, OnInit} from '@angular/core';
import {BrowserModule} from '@angular/platform-browser';

import {AppRoutingModule} from "./app-routing.module";
import {AppComponent} from './app.component';
import {NZ_I18N} from 'ng-zorro-antd/i18n';
import {zh_CN} from 'ng-zorro-antd/i18n';
import {HashLocationStrategy, LocationStrategy, registerLocaleData} from '@angular/common';
import zh from '@angular/common/locales/zh';
import {FormsModule} from '@angular/forms';
import {HttpClientModule} from '@angular/common/http';
import {BrowserAnimationsModule} from '@angular/platform-browser/animations';
import {MapInfoComponent} from './map-info/map-info.component';
import {OperateComponent} from './operate/operate.component';
import {PieChartModule} from "@swimlane/ngx-charts";
import {NgxChartsModule} from '@swimlane/ngx-charts';
import { FinancingComponent } from './financing/financing.component';
import { AreaComponent } from './area/area.component';
import { StripComponent } from './strip/strip.component';
import { ColumnarComponent } from './columnar/columnar.component';
import {NzSelectModule} from "ng-zorro-antd/select";
import {NzDatePickerModule} from "ng-zorro-antd/date-picker";

registerLocaleData(zh);

@NgModule({
  declarations: [
    AppComponent,
    MapInfoComponent,
    OperateComponent,
    FinancingComponent,
    AreaComponent,
    StripComponent,
    ColumnarComponent
  ],
  imports: [
    AppRoutingModule,
    BrowserModule,
    NgxChartsModule,
    FormsModule,
    HttpClientModule,
    BrowserAnimationsModule,
    PieChartModule,
    NzSelectModule,
    NzDatePickerModule
  ],
  providers: [{provide: LocationStrategy, useClass: HashLocationStrategy}],
  bootstrap: [AppComponent]
})
export class AppModule{

  constructor() {
  }

}
