import {AfterContentInit, Component, OnInit} from '@angular/core';
import { Chart } from '@antv/g2';
import {AppService} from "../app.service";
@Component({
  selector: 'app-area',
  templateUrl: './area.component.html',
  styleUrls: ['./area.component.css']
})
export class AreaComponent implements OnInit, AfterContentInit {

  data = [{}]

  constructor(public httpService:AppService) { }

  ngOnInit(): void {
  }

  ngAfterContentInit() {
    this.getData()
  }

  showArea() {
    const chart = new Chart({
      container: 'area',
      autoFit: true,
      height: 300,
    });
    chart.data(this.data);
    chart.scale({
      value: {
        min: 0,
        nice: true,
        alias: '利率(%)',
      },
      year: {
        range: [0, 1],
      },
    });
    chart.tooltip({
      showCrosshairs: true,
      shared: true,
    });
    chart.area().position('year*value');
    chart.line().position('year*value');
    chart.render();
  }

  getData() {
    this.httpService.get({
      url: 'https://www.taxbk.cn/qj/api/pc/achievement/areaLoanRate', success: (res: any) => {
        this.data = res.list.map((item: any) => ({
          year: item.loan_year,
          value: parseFloat(item.loan_rate)
        }))
        this.showArea()
      }
    })
  }
}
