import {AfterContentInit, AfterViewInit, Component, OnInit} from '@angular/core';
import {AppService} from "../app.service";

declare var AMap: any;

@Component({
  selector: 'app-map-info',
  templateUrl: './map-info.component.html',
  styleUrls: ['./map-info.component.css']
})
export class MapInfoComponent implements OnInit, AfterContentInit {

  constructor(public httpService:AppService) {
  }

  opts = {
    subdistrict: 0,
    extensions: 'all',
    level: 'city'
  };

  adCode = 530300;
  depth = 2;
  colors: any;
  district: any
  points = [
    {weight: 1, lnglat: [103.525303, 25.889286], x: 0, y: 0, value: 8.17}, //沾益区
    {weight: 1, lnglat: [103.096824, 26.593833], x: 0, y: 0, value: 8.17}, //会泽县
    {weight: 1, lnglat: [103.808385, 26.450964], x: 0, y: 0, value: 4.24}, //宣威市
    {weight: 1, lnglat: [103.972359, 25.668798], x: 0, y: 0, value: 5.12}, //富源县
    {weight: 1, lnglat: [103.375165, 25.198766], x: 0, y: 0, value: 3.76}, //陆良县
    {weight: 1, lnglat: [103.814262, 24.879534], x: 0, y: 0, value: 6.76}, //师宗县
    {weight: 1, lnglat: [104.151105, 25.050000], x: 0, y: 0, value: 2.12}, //罗平县
    {weight: 1, lnglat: [103.219493, 25.547233], x: 0, y: 0, value: 8.12}, //马龙县
    {weight: 1, lnglat: [103.669205, 25.464475], x: 0, y: 0, value: 2.11} //麒麟区
  ];
  areaName = [
    {
      text: '沾益区',
      anchor: 'center', // 设置文本标记锚点
      draggable: true,
      cursor: 'pointer',
      style: {
        'background-color': 'rgba(2, 66, 136, 0.45)',
        'border-width': 0,
        'text-align': 'center',
        'font-size': '10px',
        'color': '#FFFFFF',
        'angle': 0
      },
      position: [103.825303, 25.689286]
    },
    {
      text: '会泽县',
      anchor: 'center', // 设置文本标记锚点
      draggable: true,
      cursor: 'pointer',
      style: {
        'background-color': 'rgba(2, 66, 136, 0.45)',
        'border-width': 0,
        'text-align': 'center',
        'font-size': '10px',
        'color': '#FFFFFF',
        'angle': 0
      },
      position: [103.449022, 26.337218]
    },
    {
      text: '宣威市',
      anchor: 'center', // 设置文本标记锚点
      draggable: true,
      cursor: 'pointer',
      style: {
        'background-color': 'rgba(2, 66, 136, 0.45)',
        'border-width': 0,
        'text-align': 'center',
        'font-size': '10px',
        'color': '#FFFFFF',
        'angle': 0
      },
      position: [104.110261, 26.225474]
    },
    {
      text: '富源县',
      anchor: 'center', // 设置文本标记锚点
      draggable: true,
      cursor: 'pointer',
      style: {
        'background-color': 'rgba(2, 66, 136, 0.45)',
        'border-width': 0,
        'text-align': 'center',
        'font-size': '10px',
        'color': '#FFFFFF',
        'angle': 0
      },
      position: [104.182359, 25.468798]
    },
    {
      text: '陆良县',
      anchor: 'center', // 设置文本标记锚点
      draggable: true,
      cursor: 'pointer',
      style: {
        'background-color': 'rgba(2, 66, 136, 0.45)',
        'border-width': 0,
        'text-align': 'center',
        'font-size': '10px',
        'color': '#FFFFFF',
        'angle': 0
      },
      position: [103.660165, 25.033766]
    },
    {
      text: '师宗县',
      anchor: 'center', // 设置文本标记锚点
      draggable: true,
      cursor: 'pointer',
      style: {
        'background-color': 'rgba(2, 66, 136, 0.45)',
        'border-width': 0,
        'text-align': 'center',
        'font-size': '10px',
        'color': '#FFFFFF',
        'angle': 0
      },
      position: [104.075676, 24.720119]
    },
    {
      text: '罗平县',
      anchor: 'center', // 设置文本标记锚点
      draggable: true,
      cursor: 'pointer',
      style: {
        'background-color': 'rgba(2, 66, 136, 0.45)',
        'border-width': 0,
        'text-align': 'center',
        'font-size': '10px',
        'color': '#FFFFFF',
        'angle': 0
      },
      position: [104.37368, 24.883427]
    },
    {
      text: '马龙区',
      anchor: 'center', // 设置文本标记锚点
      draggable: true,
      cursor: 'pointer',
      style: {
        'background-color': 'rgba(2, 66, 136, 0.45)',
        'border-width': 0,
        'text-align': 'center',
        'font-size': '10px',
        'color': '#FFFFFF',
        'angle': 0
      },
      position: [103.519493, 25.347233]
    },
    {
      text: '麒麟区',
      anchor: 'center', // 设置文本标记锚点
      draggable: true,
      cursor: 'pointer',
      style: {
        'background-color': 'rgba(2, 66, 136, 0.45)',
        'border-width': 0,
        'text-align': 'center',
        'font-size': '10px',
        'color': '#FFFFFF',
        'angle': 0
      },
      position: [103.939205, 25.294475]
    }
  ]
  markers = [{}]
  cluster = []
  // 颜色配置
  headColors = ['#ECFFB1'];
  trailColors = ['rgba(255,178,6, 0.2)'];

  data = {
    type: "FeatureCollection",
    features: [
      {
        type: "Feature",
        properties: {
          type: 0,
          ratio: 0.0369,
          lineWidthRatio: 1
        },
        geometry: {
          type: "LineString",
          coordinates: [
            [103.449022, 26.337218],
            [103.815842, 26.182965]
          ]
        }
      },
      {
        type: "Feature",
        properties: {
          type: 0,
          ratio: 0.0369,
          lineWidthRatio: 1
        },
        geometry: {
          type: "LineString",
          coordinates: [
            [103.825303, 25.689286],
            [103.349022, 26.137218]
          ]
        }
      },
      {
        type: "Feature",
        properties: {
          type: 0,
          ratio: 0.0369,
          lineWidthRatio: 1
        },
        geometry: {
          type: "LineString",
          coordinates: [
            [104.110261, 26.225474],
            [104.552359, 25.128798]
          ]
        }
      },
      {
        type: "Feature",
        properties: {
          type: 0,
          ratio: 0.0369,
          lineWidthRatio: 1
        },
        geometry: {
          type: "LineString",
          coordinates: [
            [103.939205, 25.294475],
            [103.519493, 25.297233]
          ]
        }
      },
      {
        type: "Feature",
        properties: {
          type: 0,
          ratio: 0.0369,
          lineWidthRatio: 1
        },
        geometry: {
          type: "LineString",
          coordinates: [
            [103.939205, 25.294475],
            [103.865303, 25.689286]
          ]
        }
      },
      {
        type: "Feature",
        properties: {
          type: 0,
          ratio: 0.0369,
          lineWidthRatio: 1
        },
        geometry: {
          type: "LineString",
          coordinates: [
            [103.939205, 25.294475],
            [104.075676, 24.720119]
          ]
        }
      },
      {
        type: "Feature",
        properties: {
          type: 0,
          ratio: 0.0369,
          lineWidthRatio: 1
        },
        geometry: {
          type: "LineString",
          coordinates: [
            [104.182359, 25.468798],
            [104.28368, 25.183427]
          ]
        }
      },
      {
        type: "Feature",
        properties: {
          type: 0,
          ratio: 0.0369,
          lineWidthRatio: 1
        },
        geometry: {
          type: "LineString",
          coordinates: [
            [104.095676, 24.520119],
            [104.39368, 24.683427]
          ]
        }
      },
    ]
  }
  s1: any
  pointsCircle = [
    {weight: 1, lnglat: [103.565303, 26.589286], x: 0, y: 0, type: "r"}, //沾益区
    {weight: 1, lnglat: [103.349022, 26.037218], x: 0, y: 0, value: 8.17}, //会泽县
    {weight: 1, lnglat: [103.935842, 25.992965], x: 0, y: 0, value: 4.24}, //宣威市
    {weight: 1, lnglat: [104.515842, 26.252965], x: 0, y: 0, type: "r"}, //富源县
    {weight: 1, lnglat: [103.695303, 25.629286], x: 0, y: 0, value: 3.76}, //陆良县
    {weight: 1, lnglat: [104.182359, 25.528798], x: 0, y: 0, type: "r"}, //师宗县
    {weight: 1, lnglat: [104.552359, 25.128798], x: 0, y: 0, value: 3.76}, //陆良县
    {weight: 1, lnglat: [103.519493, 25.297233], x: 0, y: 0, value: 2.12}, //罗平县
    {weight: 1, lnglat: [104.015205, 25.174475], x: 0, y: 0, value: 8.12}, //马龙县
    {weight: 1, lnglat: [103.660165, 24.863766], x: 0, y: 0, value: 8.12}, //马龙县
    {weight: 1, lnglat: [104.095676, 24.520119], x: 0, y: 0, value: 8.12}, //马龙县
    {weight: 1, lnglat: [104.37368, 24.683427], x: 0, y: 0, value: 8.12}, //马龙县
  ];
  list = []

  ngOnInit(): void {

  }

  ngAfterContentInit() {
    this.getData()
  }

  getMapInfo() {
    this.district = new AMap.DistrictSearch(this.opts);
    this.district.search('曲靖市', (status: any, result: any) => {
      let bounds = result.districtList[0].boundaries;
      let mask = []
      for (let i = 0; i < bounds.length; i += 1) {
        mask.push([bounds[i]])
      }
      let disProvince = new AMap.DistrictLayer.Province({
        zIndex: 12,
        adcode: [530300],
        depth: 2,
        styles: {
          'fill': 'rgb(36,75,151)',
          'province-stroke': 'cornflowerblue',
          'city-stroke': 'white', // 中国地级市边界
          'county-stroke': 'rgba(0,218,226,1)', // 中国区县边界
          'stroke-width': 4
        }
      });
      let map = new AMap.Map('mapInfo', {
        mask: mask,
        center: [104.021404, 25.313303],
        disableSocket: true,
        viewMode: '3D',
        showLabel: false,
        labelzIndex: 130,
        pitch: 30,
        zoom: 8.7,
        defaultCursor: 'pointer',
        dragEnable: false,
        zoomEnable: false,
        mapStyle: "amap://styles/2185ae22c8d1535b9023a28f6bb983c0",
        layers: [
          disProvince
        ],
      });
      let maskerIn = new AMap.Marker({
        position: [116.501415, 39.926055],
        map: map
      })
      let maskerOut = new AMap.Marker({//区域外的不会显示
        position: [117.001415, 39.926055],
        map: map
      })
      //添加描边
      for (let i = 0; i < bounds.length; i += 1) {
        new AMap.Polyline({
          path: bounds[i],
          strokeColor: '#00DAE2',
          strokeWeight: 2,
          map: map
        })
      }
      // 设置定位点
      let gridSize = 80
      let cluster = new AMap.MarkerCluster(map, this.points, {
        gridSize: gridSize, // 设置网格像素大小
        renderMarker: this.getLocalCircle, // 自定义非聚合点样式
      });
      let clusterCircle = new AMap.MarkerCluster(map, this.pointsCircle, {
        gridSize: gridSize, // 设置网格像素大小
        renderMarker: this.getCircle, // 自定义非聚合点样式
      });

      // 创建纯文本标记
      this.areaName.map((item, index) => {
        let text = new AMap.Text(item);
        text.setMap(map);
      })



      let local = new Loca.Container({map: map})
      let outLineSource = new Loca.GeoJSONSource({data: this.data});
      let outLinelayer = new Loca.PulseLineLayer({
        zIndex: 100,
        opacity: 1,
        visible: true,
        zooms: [2, 22],
      });
      outLinelayer.setStyle({
        altitude: 0,
        lineWidth: (_: any, feature: any) => feature.properties.lineWidthRatio * 1 + 3,
        headColor: (_: any, feature: any) => this.headColors[feature.properties.type],
        trailColor: (_: any, feature: any) => this.trailColors[feature.properties.type],
        interval: 0.25,
        duration: 5000,
      });
      outLinelayer.setSource(outLineSource);

      local.add(outLinelayer);
      local.animate.start();getCircle
    });
  }

  getLocalCircle(context: any) {
    let tep = '<div class="test_triangle_border">\n' +
      '    <div class="popup">\n' +
      '      <div class="dot"></div>\n' +
      '     <span class="fontHead"> ' + context.data[0].value + '万<span class="fontBottom">信用户</span></span>\n' +
      '    </div>\n' +
      '  </div>'
    context.marker.setContent(tep)
    return context
  }

  getCircle(context: any) {
    let tep = '<div class="dot_circle"></div>'
    context.marker.setContent(tep)
    return context
  }

  getData() {
    this.httpService.get({
      url: 'https://www.taxbk.cn/qj/api/pc/achievement/map', success: (res: any) => {
        this.list = res.list
        res.list.forEach((item: any, index: number) => {
          if (item.name === "沾益区") {
            this.points[0].value = item.creditUser
          }
          if (item.name === "会泽县") {
            this.points[1].value = item.creditUser
          }
          if (item.name === "宣威市") {
            this.points[2].value = item.creditUser
          }
          if (item.name === "富源县") {
            this.points[3].value = item.creditUser
          }
          if (item.name === "陆良县") {
            this.points[4].value = item.creditUser
          }
          if (item.name === "师宗县") {
            this.points[5].value = item.creditUser
          }
          if (item.name === "罗平县") {
            this.points[6].value = item.creditUser
          }
          if (item.name === "马龙区") {
            this.points[7].value = item.creditUser
          }
          if (item.name === "麒麟区") {
            this.points[8].value = item.creditUser
          }
        })
        this.getMapInfo()
      }
    })
  }
}
