import {AfterContentInit, Component, OnInit} from '@angular/core';
import { Chart } from '@antv/g2';
import {AppService} from "../app.service";

@Component({
  selector: 'app-strip',
  templateUrl: './strip.component.html',
  styleUrls: ['./strip.component.css']
})
export class StripComponent implements OnInit, AfterContentInit {

  data = []

  constructor(public httpService: AppService) { }

  ngOnInit(): void {
  }

  ngAfterContentInit() {
    this.getData()
  }

  showStrip() {
    const chart = new Chart({
      container: 'strip',
      autoFit: true,
      height: 300,
    });
    chart.data(this.data);
    chart.scale('population', { nice: true, alias: "笔" });
    chart.coordinate().transpose();
    chart.tooltip({
      showMarkers: false
    });
    chart.interaction('active-region');
    chart.interval().position('country*population').size(28).label('population', {
      style: {
        fill: '#FFFFFF',
      },
      offset: 10,
      position: 'middle'
    });
    chart.render();
  }

  getData() {
    this.httpService.get({
      url: 'https://www.taxbk.cn/qj/api/pc/achievement/loanRecord', success: (res: any) => {
        this.data = res.list.map((item: any) => ({
          country: item.org_name,
          population: parseFloat(item.loan_num)
        }))
        this.showStrip()
      }
    })
  }

}
